﻿(function (global) {
  var builder = new KIKAKU.UIBuilder(global, 'UIBuilder Example', {version: '1.0.0', author: 'Atarabi', url: 'http://atarabi.com/'});

  builder
  .add('heading', 'Heading', 'UIBuilder Example')
  .add('separator', 'Separator')
  .add('number', 'Number', 0)
  .add('point', 'Point', [0, 0])
  .add('point3d', 'Point3D', [0, 0, 0])
  .add('color', 'Color', [1, 0, 0])
  .add('script', 'Get', function () {
    var property = KIKAKU.Utils.getSelectedProperty();
    if (property === null) {
      return;
    }
    
    switch (property.propertyValueType) {
      case PropertyValueType.OneD:
        this.set('Number', property.value);
        break;
      case PropertyValueType.TwoD:
      case PropertyValueType.TwoD_SPATIAL:
        this.set('Point', property.value);
        break;
      case PropertyValueType.ThreeD:
      case PropertyValueType.ThreeD_SPATIAL:
        this.set('Point3D', property.value);
        break;
      case PropertyValueType.COLOR:
        this.set('Color', property.value);
        break;
      default:
        break;
    }
  })
  .add('script', 'Apply', function () {
    var obj = KIKAKU.Utils.getSelectedProperty(true);
    if (obj === null) {
      return;
    }
  
    var property = obj.property,
    layer = obj.layer;

    switch (property.propertyValueType) {
      case PropertyValueType.OneD:
        KIKAKU.Utils.setValue(property, layer.time, this.get('Number'));
        break;
      case PropertyValueType.TwoD:
      case PropertyValueType.TwoD_SPATIAL:
        KIKAKU.Utils.setValue(property, layer.time, this.get('Point'));
        break;
      case PropertyValueType.ThreeD:
      case PropertyValueType.ThreeD_SPATIAL:
        KIKAKU.Utils.setValue(property, layer.time, this.get('Point3D'));
        break;
      case PropertyValueType.COLOR:
        KIKAKU.Utils.setValue(property, layer.time, this.get('Color'));
        break;
      default:
        break;
    }
  })
  .build();

})(this);
